;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; File:         frolic-ex.l
; Description:  Frolic airline example
; Author:       Eric G. Muehle + Jed Krohnfeldt
; Created:      15-Oct-86
; Language:     Lisp
; Package:      FROLIC
; Status:       Experimental (Do Not Distribute)
;
; (c) Copyright 1986, Eric G. Muehle, all rights reserved.
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; define a frob to describe airline flight segments

(def-class segment nil 
           :slots (carrier flight dest orig depart arrive aircraft))

;; define some flight segments

(*- #(cr segment (carrier wal)(flight 555)(dest lax)(orig slc)
             (depart 1000)(arrive 1030)(aircraft 727)))

(*- #(cr segment (carrier wal)(flight 11)(dest sjc)(orig slc)
	     (depart 930)(arrive 1010)(aircraft 737)))

(*- #(cr segment (carrier wal)(flight 556)(dest slc)(orig lax)
	     (depart 1700)(arrive 1930)(aircraft dc10)))

(*- #(cr segment (carrier wal)(flight 50)(dest slc)(orig sjc)
	     (depart 1725)(arrive 2008)(aircraft 737)))

(*- #(cr segment (carrier wal)(flight 863)(dest slc)(orig las)
	     (depart 700)(arrive 930)(aircraft 727)))

(*- #(cr segment (carrier wal)(flight 864)(dest las)(orig slc)
	     (depart 2000)(arrive 2030)(aircraft 737)))

(*- #(cr segment (carrier wal)(flight 701)(dest phx)(orig slc)
	     (depart 2000)(arrive 2030)(aircraft 737)))

(*- #(cr segment (carrier wal)(flight 710)(dest slc)(orig phx)
	     (depart 2000)(arrive 2030)(aircraft 737)))

(*- #(cr segment (carrier wal)(flight 901)(dest phx)(orig las)
	     (depart 2000)(arrive 2030)(aircraft 737)))

(*- #(cr segment (carrier wal)(flight 910)(dest las)(orig phx)
	     (depart 2000)(arrive 2030)(aircraft 737)))


(*- (find-flight _orig _dest _segments)
    (any-flight _orig _dest nil nil _segments))

(*- (any-flight _x _x _flights _cities _flights))

(*- (any-flight _orig _dest _flights _cities _segments)
    #(ma segment (orig _orig) (dest _city) (flight _segment))
    ^(not (member '_city '_cities))
    (any-flight _city _dest (_segment . _flights) (_city . _cities) _segments))

;;; example queries

; find all flights from sjc to slc
(??- (find-flight sjc slc _f))

; find a series of flights from lax to las
(??- (find-flight lax las  _f))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                             the end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
